<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Immeds</TITLE>
<link href="suif1_101.html" rel=Next>
<link href="suif1_99.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_99.html">previous</A>, <A HREF="suif1_101.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC100" HREF="suif1_toc.html#TOC100">Immediate Values</A></H2>
<P>
<A NAME="IDX695"></A>

</P>
<P>
<A NAME="IDX696"></A>
An immediate value may be an integer constant, string constant,
floating-point constant, SUIF type, symbolic address, expression
operand, or instruction, or it can be undefined.  It can be used as
the source of an <CODE>ldc</CODE> (load constant) instruction (see section <A HREF="suif1_34.html#SEC34">Load Constant Instructions</A>) or as an element of an annotation
(see section <A HREF="suif1_69.html#SEC69">Annotations</A>).  Only integers, floating-point values, and
symbolic addresses may be used in <CODE>ldc</CODE> instructions, while any
kind of immediate value may appear in an annotation.  Immediate values
are implemented by the <CODE>immed</CODE> class defined in the files
<TT>`immed.h'</TT> and <TT>`immed.cc'</TT>.

</P>
<P>
<A NAME="IDX697"></A>
The kind of value in an <CODE>immed</CODE> is identified by the <CODE>kind</CODE>
method.  This returns a member of the <CODE>immed_kinds</CODE> enumerated
type.  The members of this enumeration are:

</P>
<DL COMPACT>

<DT><CODE>im_int</CODE>
<DD>
<A NAME="IDX698"></A>
<A NAME="IDX699"></A>
Integer.  The <CODE>is_integer</CODE> method tests for this kind of immediate
and the <CODE>integer</CODE> method returns the integer value.

<DT><CODE>im_string</CODE>
<DD>
<A NAME="IDX700"></A>
<A NAME="IDX701"></A>
Character string.  The string is automatically entered in the lexicon
(see section <A HREF="suif1_102.html#SEC102">Lexicon</A>) when the <CODE>immed</CODE> is created.  The
<CODE>is_string</CODE> method checks if an <CODE>immed</CODE> is a string, and the
<CODE>string</CODE> method returns a pointer to the string.

<DT><CODE>im_float</CODE>
<DD>
<A NAME="IDX702"></A>
<A NAME="IDX703"></A>
Floating-point value.  The SUIF library stores all floating-point values
using the <CODE>double</CODE> type, so the precision is limited by the
precision for the <CODE>double</CODE> type.  The <CODE>is_flt</CODE> method checks
for this kind of immediate, and the <CODE>flt</CODE> method returns the value.

<DT><CODE>im_symbol</CODE>
<DD>
<A NAME="IDX704"></A>
<A NAME="IDX705"></A>
<A NAME="IDX706"></A>
<A NAME="IDX707"></A>
Symbolic address.  See section <A HREF="suif1_101.html#SEC101">Symbolic Addresses</A>.  The <CODE>is_symbol</CODE>
method checks if an <CODE>immed</CODE> is a symbolic address.  The <CODE>addr</CODE>
method returns the entire <CODE>sym_addr</CODE> object, but the <CODE>symbol</CODE>
and <CODE>offset</CODE> methods are also available to retrieve the symbol
pointer and integer offset separately.

<DT><CODE>im_type</CODE>
<DD>
<A NAME="IDX708"></A>
<A NAME="IDX709"></A>
SUIF type.  The <CODE>is_type</CODE> method checks for this kind of immediate,
and the <CODE>type</CODE> method returns a pointer to the SUIF type node.

<DT><CODE>im_op</CODE>
<DD>
<A NAME="IDX710"></A>
<A NAME="IDX711"></A>
Expression operand.  The immed is considered to "own" the entire
expression tree when it's in an annotation, so the same expression
shouldn't be used in another annotation or as the source for an
instruction; instead a copy should be made with the <CODE>clone</CODE>
method.  The <CODE>is_op</CODE> method checks for this kind of immediate,
and the <CODE>op</CODE> method returns the expression.

<DT><CODE>im_instr</CODE>
<DD>
<A NAME="IDX712"></A>
<A NAME="IDX713"></A>
SUIF instruction.  The immed is considered to "own" the instruction
and its expression trees when it's in an annotation, so the same
instruction shouldn't be used in another annotation or in a
<CODE>tree_node</CODE> or expression; instead a copy should be made with the
<CODE>clone</CODE> method.  The <CODE>is_instr</CODE> method checks for this kind
of immediate, and the <CODE>instr</CODE> method returns the instruction.

<DT><CODE>im_undef</CODE>
<DD>
<A NAME="IDX714"></A>
Undefined value.  This is included to signal errors by marking an
immediate as undefined.  The <CODE>is_error</CODE> method also checks for this
condition.
</DL>

<P>
Since an immediate value is small, there are no methods to change the
value of an <CODE>immed</CODE>.  Instead a variety of constructors are
provided to make it easy to create new immediate values.  That is, you
can initialize different kinds of immediates by providing arguments of
various types to constructors.

</P>
<P>
<A NAME="IDX715"></A>
<A NAME="IDX716"></A>
The <CODE>immed</CODE> class provides two print methods, <CODE>print</CODE> and
<CODE>rawprint</CODE>.  The difference between them is that the latter doesn't
escape <SAMP>`"'</SAMP> and <SAMP>`\'</SAMP> when printing strings.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_99.html">previous</A>, <A HREF="suif1_101.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
